//+------------------------------------------------------------------+
//|                                                     IndexKor.mq4 |
//|                      Copyright  2009, Urain                     |
//|                                 voidpiligrim        |
//+------------------------------------------------------------------+

/******************************************************************************************************************
  :
 1   Index-   .
   2   Index-    ( ?)=>
   =>    Index-  .( Index-)
   3    
   4   2 Index- (  chart-    ind.)   ( ?)=>
   =>    Index-  .(2 Index-)
 
 Global "SDVIG"   ,
 ( .   InitAllIndicators.mq4     "SDVIG")
  ans -  .    Index-    . Index()
 .. ind.   Open   int flag     (      ).
*******************************************************************************************************************/
#property copyright "Copyright  2009,  Urain"
//----
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Yellow
#property indicator_color2 RoyalBlue
#property indicator_color3 Aqua
#property indicator_color4 Brown
#property indicator_color5 Red
#property indicator_color6 Green
#property indicator_color7 Coral /* */
//---- input parameters  chart   separate
extern int ALERT =0; 
//---- buffers
double I_USD[];
double I_GBP[];
double I_EUR[];
double I_CHF[];
double I_JPY[];
double I_CAD[];
double I_AUD[];
double PARA[];

double GBPUSD, EURUSD, USDCHF, USDJPY, USDCAD, AUDUSD; 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   //IndicatorBuffers( 6); 
//---- indicator line

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,I_USD);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,I_GBP);

   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,I_EUR);

   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,I_CHF);

   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,I_JPY);
   
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,I_CAD);
   
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,I_AUD);
   /*   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,PARA);  */
   if(!GlobalVariableCheck( "SDVIG"))GlobalVariableSet("SDVIG",0);
//---- name for DataWindow and indicator subwindow label   
   IndicatorShortName("IndexKor");
   SetIndexDrawBegin(0,2);
  }
int deinit(){GlobalVariableDel( "SDVIG");return(0);}  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {int start_=GetTickCount();
   double ans=0; 
   double USD, GBP, EUR, CHF, JPY, CAD, AUD;
   double iUSD0,iGBP1, iEUR2, iCHF3, iJPY4, iCAD5, iAUD6;

                                              
   double USD0, GBP1, EUR2, CHF3, JPY4, CAD5, AUD6;
   //double Vpara,Npara;
//---- 
   int flag=1; 
   int i=0;int sh=GlobalVariableGet("SDVIG");  
   while(i<=500)// . Bar 500
     {if(flag==1){i=sh;}
      GBPUSD=iOpen("GBPUSD",NULL,i);//Open Close
      EURUSD=iOpen("EURUSD",NULL,i);
      USDCHF=iOpen("USDCHF",NULL,i);
      USDJPY=iOpen("USDJPY",NULL,i)*0.01;
      USDCAD=iOpen("USDCAD",NULL,i);
      AUDUSD=iOpen("AUDUSD",NULL,i);
      ans =MathPow( (USDCHF*USDJPY*USDCAD*MathPow( GBPUSD, 6)*MathPow( EURUSD, 6)*MathPow( AUDUSD, 6)), 1/7);
      //*****************************************************************************************************
            
      iUSD0=Index( 0,ans);           
      if(i==sh){USD0=iUSD0;I_USD[i]=0.0;}else{I_USD[i]=iUSD0-USD0;}
      //***********************************************************      
      
      iGBP1=Index( 1,ans);                                            //Vpara=iGBP1;
      if(i==sh){GBP1=iGBP1;I_GBP[i]=0.0;}else{I_GBP[i]=iGBP1-GBP1;}      
      //***********************************************************       
      
      iEUR2=Index( 2,ans);                                            
      if(i==sh){EUR2=iEUR2;I_EUR[i]=0.0;}else{I_EUR[i]=iEUR2-EUR2;}  
      //***********************************************************   
                 
      iCHF3=Index( 3,ans);                                            //Npara=iCHF3;
      if(i==sh){CHF3=iCHF3;I_CHF[i]=0.0;}else{I_CHF[i]=iCHF3-CHF3;}      
      //*********************************************************** 
                
      iJPY4=Index( 4,ans);
      if(i==sh){JPY4=iJPY4;I_JPY[i]=0.0;}else{I_JPY[i]=iJPY4-JPY4;}      
      //***********************************************************
      
      iCAD5=Index( 5,ans);
      if(i==sh){CAD5=iCAD5;I_CAD[i]=0.0;}else{I_CAD[i]=iCAD5-CAD5;}      
      //***********************************************************  
      
      iAUD6=Index( 6,ans);
      if(i==sh){AUD6=iAUD6;I_AUD[i]=0.0;}else{I_AUD[i]=iAUD6-AUD6;}      
      //***********************************************************      
      //if(Vpara!=0){if(Npara!=0){PARA[i]=Vpara/Npara;}else{PARA[i]=0.0;}}else{PARA[i]=0.0;}                     
      if(flag==1){i=(-1);flag=0;}    
      i++;
     }
//----
if(ALERT==1)Alert("  ", (GetTickCount()-start_)*0.001, " .");
//----
   return(0);
  }
//+------------------------------------------------------------------+
double Index(int Ind,double ans)
      {double X =0;
        
       switch(Ind)
            {
             case 0:
                   X=1/GBPUSD/EURUSD/AUDUSD*ans;
                   //USD
                   break;
             case 1:
                   X=1/EURUSD/AUDUSD*ans;
                   //GBP
                   break;
             case 2:
                   X=1/GBPUSD/AUDUSD*ans;
                   //EUR
                   break;
             case 3:
                   X=1/GBPUSD/EURUSD/AUDUSD*ans/USDCHF;
                   //CHF
                   break;
             case 4:
                   X=1/GBPUSD/EURUSD/AUDUSD*ans/USDJPY;
                   //JPY
                   break;
                   //
             case 5:
                   X=1/USDCAD/GBPUSD/EURUSD/AUDUSD*ans;
                   //CAD
                   break;
             case 6:
                   X=1/GBPUSD/EURUSD*ans; 
                   //AUD
                   break;
             default:  Alert("func Index =default ERROR");break;      
            }
              
       return(X);
       }//+----------------------------------------------------------+
 
 
       